/*
 * (C) Copyright 2004
 * Wolfgang Denk, DENX Software Engineering, wd@denx.de.
 *
 * See file CREDITS for list of people who contributed to this
 * project.
 *
 * This program is free software; you can redistribute it and/or
 * modify it under the terms of the GNU General Public License as
 * published by the Free Software Foundation; either version 2 of
 * the License, or (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program; if not, write to the Free Software
 * Foundation, Inc., 59 Temple Place, Suite 330, Boston,
 * MA 02111-1307 USA
 */

#include <config.h>

/* keep these global to avoid stack usage */
static volatile unsigned long *addr;
static volatile unsigned long cnt;
static volatile unsigned long size;

/*
 * Check memory range for valid RAM. A simple memory test determines
 * the actually available RAM size between addresses `base' and
 * `base + maxsize'.
 */
unsigned long get_ram_size(volatile unsigned long *base, unsigned long maxsize)
{
	for (cnt = (maxsize >> 3); cnt > 0; cnt >>= 1) {
		addr = base + cnt;	/* pointer arith! */
		*addr = ~cnt;
	}

	addr = base;
	*addr = 0;

	if (*addr != 0)
		return 0;

	for (cnt = 1; cnt < maxsize >> 2; cnt <<= 1) {
		addr = base + cnt;	/* pointer arith! */
		if (*addr != ~cnt) {
			size = cnt * sizeof (unsigned long);
			return size;
		}
	}

	return maxsize;
}

